Imports Microsoft.Vsa
Imports ScriptDrawObjects

Public Class ScriptDrawVsaSite
    Implements IVsaSite

    ' Global objects for use by the script.
    Private m_Objects As New Hashtable

    ' Add a global object to the hashtable.
    Public Sub AddObject(ByVal object_name As String, ByVal object_reference As Object)
        m_Objects.Add(object_name, object_reference)
    End Sub

    Public Sub GetCompiledState(ByRef pe() As Byte, ByRef debugInfo() As Byte) Implements Microsoft.Vsa.IVsaSite.GetCompiledState
        Trace.WriteLine("IVsaSite.GetCompiledState()")
        pe = Nothing
        debugInfo = Nothing
    End Sub

    ' Return an event source instance.
    Public Function GetEventSourceInstance(ByVal itemName As String, ByVal eventSourceName As String) As Object Implements Microsoft.Vsa.IVsaSite.GetEventSourceInstance
        Trace.WriteLine(String.Format("IVsaSite.GetEventSourceInstance('{0}', '{1}')", itemName, eventSourceName))
        Try
            Dim result As Object = m_Objects.Item(eventSourceName)
            Return result
        Catch ex As Exception
            Throw New VsaException(VsaError.EventSourceTypeInvalid)
        End Try
    End Function

    ' Return a global instance.
    Public Function GetGlobalInstance(ByVal name As String) As Object Implements Microsoft.Vsa.IVsaSite.GetGlobalInstance
        Try
            Dim result As Object = m_Objects.Item(name)
            Return result
        Catch ex As Exception
            Throw New VsaException(VsaError.GlobalInstanceInvalid)
        End Try
    End Function

    Public Sub Notify(ByVal notify As String, ByVal info As Object) Implements Microsoft.Vsa.IVsaSite.Notify

    End Sub

    Public Function OnCompilerError(ByVal [error] As Microsoft.Vsa.IVsaError) As Boolean Implements Microsoft.Vsa.IVsaSite.OnCompilerError
        ' Compose the error message.
        Dim msg1 As String = _
            "Error on line " & [error].Line & vbCr & vbCr
        Dim msg2 As String = _
            [error].LineText & vbCr

        ' Display the message.
        Dim dlg As New dlgError
        dlg.rchError.Text = msg1 & msg2 & [error].Description
        dlg.rchError.Select( _
            Len(msg1) + [error].StartColumn - 1, _
            [error].EndColumn - [error].StartColumn + 1)
        dlg.rchError.SelectionColor = Color.Red
        dlg.rchError.SelectionFont = New Font(dlg.rchError.SelectionFont, FontStyle.Bold)
        If dlg.ShowDialog() = DialogResult.OK Then
            ' Continue to report errors.
            Return True
        Else
            ' Stop reporting errors.
            Return False
        End If
    End Function
End Class
