Imports ScriptDrawObjects

Public Class frmScriptDraw
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuScriptEdit As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileExit = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.mnuScriptEdit = New System.Windows.Forms.MenuItem
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(292, 273)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem2})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileExit})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 0
        Me.mnuFileExit.Text = "E&xit"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 1
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuScriptEdit})
        Me.MenuItem2.Text = "&Script"
        '
        'mnuScriptEdit
        '
        Me.mnuScriptEdit.Index = 0
        Me.mnuScriptEdit.Shortcut = System.Windows.Forms.Shortcut.F5
        Me.mnuScriptEdit.Text = "&Edit Script"
        '
        'frmScriptDraw
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.picCanvas)
        Me.Menu = Me.MainMenu1
        Me.Name = "frmScriptDraw"
        Me.Text = "ScriptDraw"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Drawing variables.
    Private m_DrawingPen As Pen
    Private m_X1 As Integer
    Private m_Y1 As Integer
    Private m_X2 As Integer
    Private m_Y2 As Integer

    ' Start drawing.
    Private Sub picCanvas_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseDown
        ' Make a pen to draw the new line with.
        m_DrawingPen = New Pen(Color.Blue)
        m_DrawingPen.DashStyle = Drawing2D.DashStyle.Custom
        m_DrawingPen.DashPattern = New Single() {5, 5}

        ' Save the mouse position.
        m_X1 = e.X
        m_Y1 = e.Y
        m_X2 = e.X
        m_Y2 = e.Y
    End Sub

    ' Continue drawing.
    Private Sub picCanvas_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseMove
        ' Do nothing if we're not drawing.
        If m_DrawingPen Is Nothing Then Exit Sub

        ' Erase the previous picture.
        Dim gr As Graphics = picCanvas.CreateGraphics()
        Redraw(gr)

        ' Draw the new line.
        m_X2 = e.X
        m_Y2 = e.Y
        gr.DrawLine(m_DrawingPen, m_X1, m_Y1, m_X2, m_Y2)
    End Sub

    ' Stop drawing.
    Private Sub picCanvas_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseUp
        ' Do nothing if we're not drawing.
        If m_DrawingPen Is Nothing Then Exit Sub
        m_DrawingPen.Dispose()
        m_DrawingPen = Nothing

        ' Make a new Segment.
        g_Picture.MakeSegment(m_X1, m_Y1, m_X2, m_Y2, Color.Black, 1)

        ' Redraw.
        Redraw()
    End Sub

    ' Redraw the picture.
    Public Sub Redraw(Optional ByVal gr As Graphics = Nothing)
        If gr Is Nothing Then gr = picCanvas.CreateGraphics()

        ' Clear.
        gr.Clear(picCanvas.BackColor)

        ' Draw.
        g_Picture.Draw(gr)
    End Sub

    ' Rerdaw.
    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        Redraw(e.Graphics)
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' Display the script dialog.
    Private Sub mnuScriptEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuScriptEdit.Click
        Dim dlg As New dlgScript
        dlg.MainForm = Me
        dlg.Show()
    End Sub

    Private Sub frmScriptDraw_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim path As String = CurDir()
        If path.EndsWith("\bin") Then path = path.Substring(0, path.Length - 4)
        ChDir(path)
    End Sub
End Class
