Imports System.Drawing

Public Class Picture

    ' Raised when we create a new Segment.
    Public Event CreatedSegment(ByVal seg As Segment)

    ' Holds the Picture's Segments.
    Private m_Segments As New Collection

    ' Make a new Segment, add it to the m_Segments
    ' collection, and return it.
    Public Function MakeSegment(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer, ByVal fore_color As Color, ByVal line_width As Single) As Segment
        ' Make the new Segment.
        Dim seg As New Segment(x1, y1, x2, y2, fore_color, line_width)
        m_Segments.Add(seg)

        ' Raise the CreatedSegment event.
        RaiseEvent CreatedSegment(seg)

        ' Return the new Segment.
        Return seg
    End Function

    ' Remove all Segments.
    Public Sub Clear()
        m_Segments = New Collection
    End Sub

    ' Draw on a Graphics object.
    Public Sub Draw(ByVal gr As Graphics)
        For Each seg As Segment In m_Segments
            seg.Draw(gr)
        Next seg
    End Sub
End Class
